<?php

class Core {

	/**
	 * @var array $app
	 */
	public static  $app = array();

	/**
	 * @param string $key
	 * @return mixed
	 */
	public static function __callStatic($name, $params) {
		return Core::$app[$name];
	}

	/**
	 * Append data to app array
	 * @param string $key
	 * @param mixed $element
	 */
	public static function set($key, $element) {
		Core::$app[$key] = $element;
	}

    public static function merge($key, $element) {

        if(!isset(Core::$app[$key])) {
            Core::$app[$key] = array();
        }

        $old = Core::$app[$key];
        Core::$app[$key] = array_merge($old, $element);
    }

	public static function init($pipe) {

		//start sessions
		session_start();

		// load configuration file
		require_once dirname(__FILE__).DIRECTORY_SEPARATOR.'..'.DIRECTORY_SEPARATOR.'config.php';

		// register autoloading
		require LIB_DIR.SEPARATOR.'autoload.php';
		require_once CLASS_DIR.SEPARATOR.'class.Autoloader.php';
		Autoloader::register();


		$handler = new MiddlewareHandler();
		$handler->generate(ROOT_DIR.SEPARATOR.'pipeline.yml', $pipe);

	}
}