<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 06/04/2016
 * Time: 23:10
 */

class MiddlewareHandler {

    private $configFilePath = '';

    private $pipeline = null;

    public static $breakPipe = false;

    /**
     * Applies sequentially all middleware in the order define into
     * config file, propagates parameters to Middlewares if they exists
     * @param string $configFilePath
     */
    public function generate($configFilePath, $pipeName="admin") {

        $this->configFilePath = $configFilePath;
        $this->readConfig();

        if (!isset($this->pipeline[$pipeName])) {
            return;
        }

        foreach($this->pipeline[$pipeName] as $index => $value) {

            if(MiddlewareHandler::$breakPipe) {
                break;
            }

            extract(MiddlewareHandler::retrieveClassAndParameters($value));

            $reflection  = new ReflectionClass($className);

            $middleware = $reflection->newInstance();

            /**
             * @var AbstractMiddleware $middleware
             */
            $middleware->run($params);
        }

    }

    protected function readConfig() {

        $pipeline = yaml_parse_file($this->configFilePath);

        if ($pipeline) {
            $this->pipeline = $pipeline;
        }

    }

    public static function retrieveClassAndParameters($value) {
        $params = array();

        if (gettype($value) == 'string') {

            $className = "Middleware".ucfirst($value);
        } else {
            reset($value);
            $middlewareName = key($value);
            $params = $value[$middlewareName];
            $className = "Middleware".ucfirst($middlewareName);

        }

        return array(
            "className" => $className,
            "params" => $params
        );
    }

}