<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 09/04/2016
 * Time: 11:21
 */

class MiddlewareAuth extends AbstractMiddleware {

    /**
     * @inheritDoc
     */
    public function action($param)
    {
        $param = $param[0];

        if (!isset($param['params'])) {
            throw new CoreException(CoreException::INVALID_PARAMETERS, 'MiddlewareAuth : params parameter required');
        }

        $param = $param['params'];

        $param = array_reduce($param, function($carry, $item) {
            return array_merge($carry, $item);
        }, array());


        if (!isset($param['type'])) {
            throw new CoreException(CoreException::INVALID_PARAMETERS, 'MiddlewareAuth : type parameter required');
        }

        $className = "Middleware".ucfirst($param['type']);
        $reflection  = new ReflectionClass($className);

        $middleware = $reflection->newInstance();

        /**
         * @var AbstractMiddleware $middleware
         */
        $middleware->run($param);
    }
}