<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 09/04/2016
 * Time: 13:20
 */

class MiddlewareDebug extends AbstractMiddleware {

    /**
     * @inheritDoc
     */
    public function action($param) {

        $middlewares = array();

        foreach($param as $element) {

            extract(MiddlewareHandler::retrieveClassAndParameters($element));

            $active = $params == 'active' ? true : false;

            $reflection = new ReflectionClass($className);
            $middleware = $reflection->newInstance($active);
            $middlewares[] = $middleware;
        }

        $html = $this->generateDebugHtml($middlewares);

        $optParams = array('debugHtml' => $html);

        Core::merge('optParams', $optParams);


    }

    public function generateDebugHtml($debugMiddlewares) {

        $tabs = '';
        $content = '';

        foreach($debugMiddlewares as $middleware) {

            $data = $middleware->getData();

            $active = $data['active'];
            $name = $data['name'];

            $activeStringContent = $active ? 'in active' : '';
            $activeStringTab = $active ? 'active' : '';

            $tabs .= sprintf('<li class="%s"><a href="#%s" role="tab" data-toggle="tab">%s</a></li>', $activeStringTab, $name, ucfirst($name));
            $content .= sprintf('<div class="tab-pane fade %s" id="%s">%s</div>', $activeStringContent, $name, $name);
        }

        return <<< HTML
        <!-- Tabs Below Right -->
                <div class='tabs-x tabs-below tab-bordered tab-align-right'>
                    <div class="tab-content">
                        {$content}
                    </div>
                    <ul class="nav nav-tabs" role="tablist">
                        {$tabs}
                    </ul>
                </div>
            </div>
HTML;
    }
}