<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 09/04/2016
 * Time: 18:41
 */

class MiddlewareCss extends AbstractMiddleware {
    /**
     * @inheritDoc
     */
    public function action($param) {
        // TODO: Implement action() method.

        $param = array_reduce($param, function($carry, $item) {
            return array_merge($carry, $item);
        }, array());

        if (!isset($param['input'])) {
            throw new CoreException(CoreException::INVALID_PARAMETERS, 'MiddlewareCss : input parameter required');
        }

        if (!isset($param['output'])) {
            throw new CoreException(CoreException::INVALID_PARAMETERS, 'MiddlewareCss : output parameter required');
        }

        $input = ROOT_DIR.SEPARATOR.$param['input'];
        $output = ROOT_DIR.SEPARATOR.$param['output'];

        if (!is_dir($output)) {
            mkdir($output);
        }

        $this->walk($input, $output);

    }

    /**
     * Walk on dir to found files
     * @param $base_dir string Absolute root dir to scanned dir
     * @return array <string> Relative file path to files found
     */
    protected function walk($base_dir, $prec) {

        SassCompiler::run($base_dir.SEPARATOR, $prec.SEPARATOR);

        $scan = scandir($base_dir);

        foreach($scan as $elem) {

            if (in_array($elem, array('.', '..'))) { continue; }

            if (is_dir($base_dir.SEPARATOR.$elem)) {

                if (!is_dir($prec.SEPARATOR.$elem)) {
                    mkdir($prec.SEPARATOR.$elem);
                }

                $this->walk($base_dir.SEPARATOR.$elem, $prec.$elem.SEPARATOR);
            }

        }
    }

}